/*
 * @(#)Plan.java	1.00 11/20/01
 *
 * Copyright (c) 2001 by Concurrent Software System Lab (CSSL), Computer Science 
 * Department, The University of Illinois at Chicago (UIC). All Rights Reserved.
 * 
 * CSSL grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to CSSL.
 * 
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. CSSL AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL CSSL OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF CSSL HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 * 
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

package agent.generic;

import java.lang.reflect.Array;

public class Plan {

    private int priority;
    private String goalName;
    private boolean[] conditions;
    
    public void setPriority(int priority) {
        this.priority = priority;
    }

    public int getPriority() {
        return priority;
    }

    public void setGoalName(String goalName) {
        this.goalName = goalName;
    }

    public String getGoalName() {  
        return goalName;
    }

    public void setConditions(boolean[] conditions) {
 
        conditions = new boolean[Array.getLength(conditions)];

        for (int i=0; i<Array.getLength(conditions); i++) {
            this.conditions[i] =  conditions[i];      
        }
    }
        
    public void setConditionI(boolean condition, int i) {
     
        if (i < Array.getLength(conditions)) {
            this.conditions[i] = condition;
        } else return;
    }

    public boolean getConditionI(int i) {
      
        if (i < Array.getLength(conditions)) {
            return conditions[i];
        } else {
           System.out.println("This condition has not been defined !!!");
        } 

        return false;
    }

    public void start() {
        System.out.println("This method needs to be overriden by its subclass");
    }   
}