/*
 * @(#)SellerConsole.java (for Seller)	1.00 11/20/01
 *
 * Copyright (c) 2001 by Concurrent Software System Lab (CSSL), Computer Science 
 * Department, The University of Illinois at Chicago (UIC). All Rights Reserved.
 * 
 * CSSL grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to CSSL.
 * 
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. CSSL AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL CSSL OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF CSSL HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 * 
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

package agent.sellerUI;

import agent.seller.Seller;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;


public class SellerConsole extends JPanel {

    private Seller seller;
    private ActionListener menuListener;
    private JFrame frame;
    private JMenuBar menuBar;
    private JLabel label;

    // The tab pane that holds the demo
    private JTabbedPane tabbedPane = null;
    private JPanel agentListPanel = null;
    private JPanel contentPanel = null;
    private JEditorPane demoSrcPane = null;

    private JList agentList;
    private DefaultListModel agentListModel;
    private static int oldIndexInAgentList = 0;      

    private JTextArea textArea;
    private JTextArea textArea1;
 
    private static String LOG_FILE = "Content"; // renamed later 
    private static String LOG_FILE_SAVE = "Conetent.Save"; // later 

    public static boolean startAgent = false;

    
    // Main Function
    public static void main(String[] args) {
        SellerConsole console = new SellerConsole("Hello World!", null);
        console.create();
        
        console.textArea.append("haha, I got it!");
    } 
 
    // ===========
    // Constructor
    // ===========
    
    public SellerConsole(String title, Seller theSeller) {    

        this.seller = theSeller;

        menuListener = new MenuActionListener();
        frame = new JFrame(title);       

        agentListModel = new DefaultListModel();
        agentList = new JList(agentListModel);
        agentList.setCellRenderer(new AgentLogoListCellRenderer());
        agentList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        agentList.addListSelectionListener(new AgentListSelectionListener());  
        agentList.setFixedCellWidth(100);
        
        textArea = new JTextArea();
        textArea1 = new JTextArea();          

    }
 
    // ====================
    // create the interface
    // ====================
    
    public void create() {
 
       frame.addWindowListener(new WindowAdapter() {
           public void windowClosing(WindowEvent event) {
               frame.setVisible(false);
               frame.removeWindowListener(this);
               if (seller.joinMgr != null) seller.joinMgr.terminate();
               frame.dispose();
               System.out.println("\nJoin Manager Terminated ... exiting ...\n");
               System.exit(0);
           }
        }); 

        EmptyBorder border5 = new EmptyBorder(5,0,0,0);

        Container pane = frame.getContentPane();
        pane.setLayout(new BorderLayout());

        JPanel top = new JPanel();
	  top.setLayout(new BorderLayout());
	  pane.add(top, BorderLayout.NORTH);

	  menuBar = createMenuBar();
	  top.add(menuBar, BorderLayout.NORTH);

        JPanel labelPanel = new JPanel();
	  labelPanel.setLayout(new BorderLayout());
        labelPanel.setBorder(border5);
	  label = new JLabel("Seller Agent (ID: N/A)");
        ImageIcon image = new ImageIcon("..\\images\\seller.gif",  "Seller.icon");
        label.setIcon(image);
        label.setHorizontalAlignment(SwingConstants.CENTER); 
	  labelPanel.add(label, BorderLayout.CENTER);
	  top.add(labelPanel, BorderLayout.SOUTH);

	  tabbedPane = new JTabbedPane();
	  pane.add(tabbedPane, BorderLayout.CENTER);
	  tabbedPane.getModel().addChangeListener(new TabListener());

        agentListPanel = new JPanel();
	  agentListPanel.setLayout(new BorderLayout());
	  agentListPanel.setBorder(new EtchedBorder());
	  tabbedPane.addTab("Agent List", agentListPanel);

        contentPanel = new JPanel();
	  contentPanel.setLayout(new BorderLayout());
	  contentPanel.setBorder(new EtchedBorder());
	  tabbedPane.addTab("Current Log", contentPanel);


        // Add html src code viewer 
	  /* demoSrcPane = new JEditorPane("text/html", "SourceCode.loading ...");
	  demoSrcPane.setEditable(false);
    
	  JPanel p = new JPanel();
	  p.setLayout(new BorderLayout() );
	  p.add(demoSrcPane, BorderLayout.CENTER);
    
	  JScrollPane scroller = new JScrollPane();
	  scroller.getViewport().add(p);
    
	  tabbedPane.addTab(
	      "SRC Label",
	      null,
	      scroller,
	      "SRc_Tooltip"
	  ); */
        
                
        // create and configure split pane
        JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        splitPane.setContinuousLayout(true);
        splitPane.setOneTouchExpandable(true);
       
        JScrollPane scrollPaneWest = new JScrollPane(agentList);
        JScrollPane scrollPaneCenter = new JScrollPane(textArea);
        JScrollPane scrollPaneCenter1 = new JScrollPane(textArea1);
 
        splitPane.setLeftComponent(scrollPaneWest);
        scrollPaneWest.setMinimumSize(new Dimension(100, 100)); 
        splitPane.setRightComponent(scrollPaneCenter);
        scrollPaneCenter.setMinimumSize(new Dimension(100, 100)); 

        agentListPanel.add(splitPane, BorderLayout.CENTER); 

        contentPanel.add(scrollPaneCenter1, BorderLayout.CENTER);
            
        frame.setJMenuBar(menuBar);
        frame.setSize(500, 380);
        frame.setVisible(true);
    }

    // ==================
    // additional methods
    // ==================

    public void appendInfo(String message) {                
         int index = agentList.getSelectedIndex();
        
         if (index != 0 && index != -1) {
             Object obj = agentList.getSelectedValue();
             if (message.indexOf(obj.toString()) != -1) {
                 textArea.append(message + "\n");
                 textArea1.append(message + "\n");
             }
         } else {           
             textArea.append(message + "\n");
             textArea1.append(message + "\n");

         }

         // System.out.println(message);

         File logFile = new File(LOG_FILE);
         if (!logFile.exists()) {
                System.out.println("FILE NOT EXISTS\n");
                return;
         }


         try {
            FileWriter fileWriter = new FileWriter(LOG_FILE, true);
            BufferedWriter writer = new BufferedWriter(fileWriter);            
            writer.write(message); 
            writer.newLine();         
            writer.close();
        } catch (IOException e) { 
            System.out.println("IOException in method appendInfo: " + e);
        }   
    }

    public void appendInfoNoln(String message) {        
        
         // textArea.append(message);
         // textArea1.append(message);
         System.out.print(message);

    }


    public void showSelectedContent(String message, boolean list) {        
  
        if (list) {
            textArea.append(message + "\n");
        } else { 
            textArea1.append(message + "\n");
        }
    }

    public void showBrowseInfo(String info) {
       
       tabbedPane.getModel().setSelectedIndex(1);
       textArea1.setText(null); 
       
       showSelectedContent(info, false);

    } 
 
    public void setLabelText(String labelText) {

        label.setText(labelText);
    }

    public void setAgentLogFile() {

        LOG_FILE = seller.getAgentName() + ".log";

        if (LOG_FILE.equals("N/A.log")) {
            LOG_FILE = "NoServiceID.log";
        }

        try {
            FileWriter fileWriter = new FileWriter(LOG_FILE);
            fileWriter.close();
        } catch (IOException e) { 
            System.out.println("IOException in setAgentLogFile: " + e);
        }   
    }

    public void saveAgentLogFile() {
        
        int c;

        LOG_FILE_SAVE = seller.getAgentName() + ".log.save";

        if (LOG_FILE_SAVE.equals("N/A.log.save")) {
            LOG_FILE_SAVE = "NoServiceID.log.save";
        }

        try {
            FileReader fileReader = new FileReader(LOG_FILE);
            FileWriter fileWriter = new FileWriter(LOG_FILE_SAVE);
          
            while ((c = fileReader.read()) != -1) {
                fileWriter.write(c);
            }
         
            fileReader.close();
            fileWriter.close();
        } catch (IOException e) { 
            System.out.println("IOException in saveAgentLogFile: " + e);
        }   
    }
    

    public void showAgentLogFile() {
       
       tabbedPane.getModel().setSelectedIndex(1);
       textArea1.setText(null);     
 
       LOG_FILE_SAVE = seller.getAgentName() + ".log.save";

       if (LOG_FILE_SAVE.equals("N/A.log.save")) {
           LOG_FILE_SAVE = "NoServiceID.log.save";
       }

       File logFile = new File(LOG_FILE_SAVE);
       if (!logFile.exists()) {
            showSelectedContent("File \"" + LOG_FILE_SAVE + 
                                "\" does NOT exist!", false);
            return;
       }
       
       showSelectedContent("C:\\Tmp\\MyJava\\Mad-Pro\\src\\agent\\" + 
                            seller.getMyPackageName() + "\\" + LOG_FILE_SAVE, false);
       showSelectedContent("", false);

       try { 
            FileReader fileReader = new FileReader(LOG_FILE_SAVE);
            BufferedReader reader = new BufferedReader(fileReader);
            String line = reader.readLine();
                while (line != null) {
                    showSelectedContent(line, false);
                    line = reader.readLine();
                }
                fileReader.close();
        } catch (IOException e) { 
            System.out.println("IOException in method appendInfo: " + e);
        }   
    } 


    public void deleteAgentLogFile() {

        LOG_FILE_SAVE = seller.getAgentName() + ".log.save";

        if (LOG_FILE_SAVE.equals("N/A.log.save")) {
            LOG_FILE_SAVE = "NoServiceID.log.save";
        }

        System.out.println("Deleting \"" + LOG_FILE_SAVE +"\" file ...\n");
        File logFile = new File(LOG_FILE_SAVE);
        if (logFile.exists()) {
            logFile.delete();
        }
    }


    public void addAgentInList(String agentName) {

        agentListModel.addElement(agentName);
    }
 
    public void clearAgentInList() {
          
        agentListModel.removeRange(1, agentListModel.size()-1);
        agentList.setSelectedIndex(0);
    }
  
    public void removeAgentInList(String agentName) {

        agentListModel.removeElement(agentName);
 
    }

    public boolean confirmWindow(String question) {

        boolean answer = 
            JOptionPane.showConfirmDialog(null, question) ==
                                                JOptionPane.YES_OPTION; 
        return answer;     
    }


    private void exitJoinManager() {

        boolean exitJM = 
            JOptionPane.showConfirmDialog(null, "Are you sure to EXIT?") ==
                                                 JOptionPane.YES_OPTION;      

        if (exitJM) {
            if (seller.joinMgr != null) seller.joinMgr.terminate();
            frame.dispose();
            // frame = null;
            System.out.println("\nJoin Manager Terminated ... exiting ...\n");
            System.out.println("Deleting \"" + LOG_FILE +"\" file ...\n");
            File logFile = new File(LOG_FILE);
            if (logFile.exists()) {
                // System.out.println("FILE EXISTS\n");
                // log file deleted when the virtual machine terminates. 
                logFile.deleteOnExit();
            }
            System.out.println("===================");
            System.out.println("Execution Finished!");
            System.out.println("==================="); 
            System.exit(0);
        }
    }


    private JMenuBar createMenuBar() {

        JMenuBar menuBar = new JMenuBar();

        //
        // File Menu, F - Mnemonic
        //
        JMenu fileMenu = new JMenu("File");
        fileMenu.setMnemonic(KeyEvent.VK_F);
        menuBar.add(fileMenu);
                 
        // File->Save, S - Mnemonic
        JMenuItem saveMenuItem = new JMenuItem("Save", KeyEvent.VK_S);
        saveMenuItem.addActionListener(menuListener);
        KeyStroke ctrlSKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_S, Event.CTRL_MASK);
        saveMenuItem.setAccelerator(ctrlSKeyStroke);
        fileMenu.add(saveMenuItem);

        // File->Show, W - Mnemonic
        JMenuItem showMenuItem = new JMenuItem("Show", KeyEvent.VK_W);
        showMenuItem.addActionListener(menuListener);
        KeyStroke ctrlWKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_W, Event.CTRL_MASK);
        showMenuItem.setAccelerator(ctrlWKeyStroke);
        fileMenu.add(showMenuItem);

        // File->Delete, D - Mnemonic
        JMenuItem deleteMenuItem = new JMenuItem("Delete", KeyEvent.VK_D);
        deleteMenuItem.addActionListener(menuListener);
        KeyStroke ctrlDKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_D, Event.CTRL_MASK);
        deleteMenuItem.setAccelerator(ctrlDKeyStroke);
        fileMenu.add(deleteMenuItem);
 
   
        // Separator
        fileMenu.addSeparator();
 
        // File->Exit, X - Mnemonic
        JMenuItem exitMenuItem = new JMenuItem("Exit", KeyEvent.VK_X);
        exitMenuItem.addActionListener(menuListener);
        KeyStroke ctrlXKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_X, Event.CTRL_MASK);
        exitMenuItem.setAccelerator(ctrlXKeyStroke);
        fileMenu.add(exitMenuItem);

        // 
        // Edit Menu, E - Mnemonic
        //
        JMenu editMenu = new JMenu("Edit");
        editMenu.setMnemonic(KeyEvent.VK_E);
        menuBar.add(editMenu);
        
        // Edit->Knowledge, K - Mnemonic, CTRL-K - Accelerator
        JMenuItem knowledgeMenuItem = new JMenuItem("Knowledge", KeyEvent.VK_K);
        knowledgeMenuItem.addActionListener(menuListener);
        KeyStroke ctrlKKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_K, Event.CTRL_MASK);
        knowledgeMenuItem.setAccelerator(ctrlKKeyStroke);
        editMenu.add(knowledgeMenuItem);

        // Edit->Goal, G - Mnemonic, CTRL-G - Accelerator
        JMenuItem goalMenuItem = new JMenuItem("Goal", KeyEvent.VK_G);
        goalMenuItem.addActionListener(menuListener);
        KeyStroke ctrlGKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_G, Event.CTRL_MASK);
        goalMenuItem.setAccelerator(ctrlGKeyStroke);
        editMenu.add(goalMenuItem);

        // Edit->Plan, P - Mnemonic, CTRL-V - Accelerator, Disabled
        JMenuItem planMenuItem = new JMenuItem("Plan", KeyEvent.VK_P);
        planMenuItem.addActionListener(menuListener);
        KeyStroke ctrlVKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_V, Event.CTRL_MASK);
        planMenuItem.setAccelerator(ctrlVKeyStroke);
        // planMenuItem.setEnabled(false);
        editMenu.add(planMenuItem);

        // Separator
        editMenu.addSeparator();

        // Edit->Find, F - Mnemonic, F3 - Accelerator
        JMenuItem findMenuItem = new JMenuItem("Find", KeyEvent.VK_F);
        findMenuItem.addActionListener(menuListener);
        KeyStroke f3KeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_F3, 0);
        findMenuItem.setAccelerator(f3KeyStroke);
        editMenu.add(findMenuItem);


        //
        // Run Menu, R - Mnemonic
        //
        JMenu runMenu = new JMenu("Run");
        runMenu.setMnemonic(KeyEvent.VK_R);
        menuBar.add(runMenu);
 
        // Run->Start, R - Mnemonic, CTRL-R - Accelerator
        JMenuItem startMenuItem = new JMenuItem("Start", KeyEvent.VK_R);
        startMenuItem.addActionListener(menuListener);
        KeyStroke ctrlRKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_R, Event.CTRL_MASK);
        startMenuItem.setAccelerator(ctrlRKeyStroke);
        runMenu.add(startMenuItem);       
 
        // Run->Stop, O - Mnemonic, CTRL-O - Accelerator
        JMenuItem stopMenuItem = new JMenuItem("Stop", KeyEvent.VK_O);
        stopMenuItem.addActionListener(menuListener);
        KeyStroke ctrlOKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_O, Event.CTRL_MASK);
        stopMenuItem.setAccelerator(ctrlOKeyStroke);
        runMenu.add(stopMenuItem);       

        //
        // Tool Menu, T - Mnemonic
        //
        JMenu toolMenu = new JMenu("Tool");
        toolMenu.setMnemonic(KeyEvent.VK_T);
        menuBar.add(toolMenu);
        
        // Tool->Browser, B - Mnemonic, CTRL-B - Accelerator
        JMenuItem browseMenuItem = new JMenuItem("Browse", KeyEvent.VK_B);
        browseMenuItem.addActionListener(menuListener);
        KeyStroke ctrlBKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_B, Event.CTRL_MASK);
        browseMenuItem.setAccelerator(ctrlBKeyStroke);
        toolMenu.add(browseMenuItem);

         // Tool->Update Services, U - Mnemonic, CTRL-U - Accelerator
        JMenuItem updateMenuItem = new JMenuItem("Update", KeyEvent.VK_U);
        updateMenuItem.addActionListener(menuListener);
        KeyStroke ctrlUKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_U, Event.CTRL_MASK);
        updateMenuItem.setAccelerator(ctrlUKeyStroke);
        toolMenu.add(updateMenuItem);

        // Tool->Test Message, M - Mnemonic, CTRL-M - Accelerator
        JMenuItem testmsgMenuItem = new JMenuItem("TestMsg", KeyEvent.VK_M);
        testmsgMenuItem.addActionListener(menuListener);
        KeyStroke ctrlMKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_M, Event.CTRL_MASK);
        testmsgMenuItem.setAccelerator(ctrlMKeyStroke);
        toolMenu.add(testmsgMenuItem);

        return menuBar;
    }


    // ==================
    // additional classes
    // ==================

    private class TabListener implements ChangeListener {

        public void stateChanged(ChangeEvent ev) {
	     SingleSelectionModel model = (SingleSelectionModel) ev.getSource();
	     boolean contentSelected = model.getSelectedIndex() == 1;
           int index = agentList.getSelectedIndex();

           if (contentSelected) {
               Object obj = agentList.getSelectedValue();
               if (obj == null) return;
               textArea1.setText(null); 
               try { 
                   FileReader fileReader = new FileReader(LOG_FILE);
                   BufferedReader reader = new BufferedReader(fileReader);
                   String line = reader.readLine();
                   while (line != null) { //if line contains the obj, print
                       if (index == 0 || line.indexOf(obj.toString()) != -1)
                           showSelectedContent(line, false);
                       line = reader.readLine();
                   }
                   fileReader.close();
               } catch (IOException e) { 
                    System.out.println("IOException in method stateChanged " +
                                       "(TabListener): " + e);
               }   
           }
    
	     /* if(currentTabDemo != currentDemo && demoSrcPane != null && srcSelected) {
	  	  demoSrcPane.setText(getString("SourceCode.loading"));
		  repaint();
	       }
	       if(currentTabDemo != currentDemo && srcSelected) {
		  currentTabDemo = currentDemo;
		  setSourceCode(currentDemo);
	     } */
     	  }
    }


    private class AgentListSelectionListener implements ListSelectionListener {
        
        public void valueChanged(ListSelectionEvent ex) {
            String line = null;            
 
            int newIndex = agentList.getSelectedIndex();
            if (newIndex != oldIndexInAgentList) {
                oldIndexInAgentList = newIndex;
                Object obj = agentList.getSelectedValue();
                System.out.println("In list selection listener: " + obj.toString());

                textArea.setText(null); 
                try { 
                    FileReader fileReader = new FileReader(LOG_FILE);
                    BufferedReader reader = new BufferedReader(fileReader);
                    line = reader.readLine();
                    while (line != null) {    //if line contains the obj, print
                        if (newIndex == 0 || line.indexOf(obj.toString()) != -1)
                            showSelectedContent(line, true);
                        line = reader.readLine();
                    }
                    fileReader.close();
                } catch (IOException e) { 
                    System.out.println("IOException in method valueChanged " +           
                                       "(AgentListSelectionListener): " + e);
                }   
            }
        }
    }

    private class MenuActionListener implements ActionListener {

        public void actionPerformed(ActionEvent actionEvent){

            System.out.println("Selected: "+actionEvent.getActionCommand());

            if ((actionEvent.getActionCommand()).equals("Exit")) {
                exitJoinManager();
            } else if ((actionEvent.getActionCommand()).equals("Save")) {
                saveAgentLogFile();
            } else if ((actionEvent.getActionCommand()).equals("Show")) {
                showAgentLogFile();
            } else if ((actionEvent.getActionCommand()).equals("Delete")) {
                deleteAgentLogFile();
            } else if ((actionEvent.getActionCommand()).equals("Knowledge")) {
                seller.editKnowledge();
            } else if ((actionEvent.getActionCommand()).equals("Goal")) {
                seller.editGoal();
            } else if ((actionEvent.getActionCommand()).equals("Plan")) {
                seller.editPlan();
            } else if ((actionEvent.getActionCommand()).equals("Start")) {
                if (!startAgent) {
                    seller.startAgent();
                    startAgent = true;   
                } else {
                    appendInfo("You may start the seller agent only ONCE !!!");
                }
            } else if ((actionEvent.getActionCommand()).equals("Stop")) { 
                seller.stopAgent();
            } else if ((actionEvent.getActionCommand()).equals("Browse")) { 
                seller.browseServices();
            } else if ((actionEvent.getActionCommand()).equals("Update")) { 
                tabbedPane.getModel().setSelectedIndex(0);
                seller.updateServices();
            } else if ((actionEvent.getActionCommand()).equals("TestMsg")) {
                seller.testMessage();  
            }
        } // method actionPerformed
    } // class MenuActionListener 
    

    private class AgentLogoListCellRenderer extends DefaultListCellRenderer {
        public Component getListCellRendererComponent(JList list,
                                                      Object value,
                                                      int index,
                                                      boolean isSelected,
                                                      boolean cellHasFocus) {
            JLabel retValue = (JLabel) super.getListCellRendererComponent(
  		                     list, value, index, isSelected, cellHasFocus);
            ImageIcon images[] = new ImageIcon[2];
            images[0] = new ImageIcon("..\\images\\seller.gif",  "Seller.icon");
 	      images[1] = new ImageIcon("..\\images\\buyer.gif",  "Buyer.icon");

            if (index == 0) retValue.setIcon(images[0]);
            else retValue.setIcon(images[1]);

	      return retValue;
        }
    }
}
