@echo off

rem /*
rem 
rem Copyright 2001 Concurrent Software System Lab (CSSL) Computer Science
rem Department The University of Illinois at Chicago All Rights Reserved.
rem 
rem The contents of this file are made available under and subject to the
rem Research Use Rights of the Sun Community Source License v 3.0 (the
rem "License"). Software distributed under the License is distributed on an
rem "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
rem See the License for the specific language governing rights and
rem limitations under the License.
rem 
rem Contributor: Concurrent Software System Lab, UIC.  
rem 
rem Version 1.00
rem 
rem */

set PROGRAM_NAME=%0%
set JINIHOME=C:\CSSL\MyJini\jini1_1

set INTF_NAME=TrainTicketSeller
set IMPL_NAME=%INTF_NAME%
set PKG0=agent
set PKG1=generic


set USAGE=usage: %PROGRAM_NAME% [-usage] [-help] [-src src] [-src_codebase src_codebase] [-jdk jdk] -host hostname [-port port] [-jit] [-sec] [-nojar] [-groups g0 g1 ...]

set ARG_LIST=(-src -src_codebase -jdk -host -port -groups)

set SRC_HOME=C:\CSSL\MyJava\Mad-Pro
set SRC_CODEBASE=C:/CSSL/MyJava/Mad-Pro
set JDK_HOME=C:\jdk1.3.1
set HTTP_SERVER_HOST=oemcomputer
set PORT=8080
set JIT=
set SEC=NONE
set USE_JAR_EXE=true
set GROUPS=
set SET_GROUPS=false

rem Parse the argument list
:loop
if "%1"=="" goto endloop
set ARG=%1

for %%f in %ARG_LIST% do if %ARG%==%%f shift

rem *** test for all expected single-item args
if -usage==%ARG% goto showUsage
if -help==%ARG% goto showHelp

if -jit==%ARG% set JIT=-Djava.compiler=NONE
if -jit==%ARG% set SET_GROUPS=false
if -sec==%ARG% set SEC=access,failure
if -sec==%ARG% set SET_GROUPS=false
if -nojar==%ARG% set USE_JAR_EXE=false
if -nojar==%ARG% set SET_GROUPS=false

rem *** if there are no args left, then exit loop
if "%1"=="" goto endloop

rem *** test for all expected double-item args
if -src==%ARG% set SRC_HOME=%1
if -src==%ARG% set SET_GROUPS=false
if -src_codebase==%ARG% set SRC_CODEBASE=%1
if -src_codebase==%ARG% set SET_LOCATORS=false
if -jdk==%ARG% set JDK_HOME=%1
if -jdk==%ARG% set SET_GROUPS=false
if -host==%ARG% set HTTP_SERVER_HOST=%1:
if -host==%ARG% set SET_GROUPS=false
if -port==%ARG% set PORT=%1
if -port==%ARG% set SET_GROUPS=false

if %SET_GROUPS%==true set GROUPS=%GROUPS%,%1
if -groups==%ARG% set GROUPS=%1
if -groups==%ARG% set SET_GROUPS=true

shift
goto loop
:endloop
if %HTTP_SERVER_HOST%=="HOSTNAME_MUST_BE_INPUT" echo -host option has to be supplied
if %HTTP_SERVER_HOST%=="HOSTNAME_MUST_BE_INPUT" goto showUsage

echo.
echo %PROGRAM_NAME% ---

set THIS_JAR=%SRC_HOME%\jars\%INTF_NAME%.jar
set EXE_JAR=%SRC_HOME%/jars/%INTF_NAME%.jar
set EXPORT_CODEBASE="http://%HTTP_SERVER_HOST%:%PORT%/%INTF_NAME%-srvc-dl.jar"
set POLICY_FILE=%JINIHOME%/policy/policy.all
set POLICY_CODEBASE_LOCAL=file:/%SRC_CODEBASE%/jars/%INTF_NAME%.jar
set POLICY_CODEBASE_JINI_CORE=file:/%SRC_CODEBASE%/jars/jini-core.jar
set POLICY_CODEBASE_JINI_EXT=file:/%SRC_CODEBASE%/jars/jini-ext.jar

set OLD_Path=%Path%
set OLD_CLASSPATH=%CLASSPATH%
set Path=%JDK_HOME%\bin;%Path%
set CLASSPATH=
echo.
java -version
echo.

set CP=%SRC_HOME%\jars\jini-core.jar;%SRC_HOME%\jars\jini-ext.jar;%SRC_HOME%\jars\sun-util.jar;%THIS_JAR%
set EXE_CLASS=%PKG0%.%PKG1%.%IMPL_NAME%
set EXE_ARGS=%GROUPS%

if %USE_JAR_EXE%==false java -cp %CP% %JIT% -Djava.security.debug=%SEC% -Djava.security.policy=%POLICY_FILE% -Djava.rmi.server.codebase=%EXPORT_CODEBASE% %EXE_CLASS% %EXE_ARGS%
if %USE_JAR_EXE%==true java %JIT% -Djava.security.debug=%SEC% -Djava.security.policy=%POLICY_FILE% -Djava.rmi.server.codebase=%EXPORT_CODEBASE% -jar %EXE_JAR% %EXE_ARGS%

rem *** END of Script ***
goto endScript

rem *** USAGE ***
:showUsage
echo.
echo %USAGE%
echo.
goto exitScript

rem *** HELP ***
:showHelp
echo.
echo %USAGE%
echo where options include:
echo.
echo  -src     [base dir of example source,class,jar files]
echo           Example: enter d:\home, then policy files, tools and 
echo                    source files assumed under d:\home\src
echo                    class files assumed under d:\home\classes
echo                    jar files assumed under d:\home\jars
echo           (Default = %SRC_HOME%).
echo  -src_codebase [base dir of example source files, used to specify 
echo           path in policy files]
echo           Note: input to this option should be the same as for
echo           -src, except '/' should be used instead of '\'.
echo           Example: enter c:/home, permissions will be 
echo           granted to file:/c:/home/jars/%INTF_NAME%.jar in
echo           corresponding policy files.
echo           (Default = %SRC_CODEBASE%).
echo  -jdk     [base dir of JDK]
echo           Example: enter d:\jdk1.2, bin assumed in d:\jdk1.2\bin
echo           (Default = %JDK_HOME%).
echo  -host    [hostname of HTTP server -- for RMI codebase]
echo           (Default = %HTTP_SERVER_HOST%).
echo  -port    [port number on which the HTTP server listens]
echo           (Default = %PORT%).
echo  -jit     [disable the JIT]
echo           (Default = JIT enabled).
echo  -sec     [enable security debugging]
echo           (Default = disabled).
echo  -nojar   [disable the JAR execution mechanism]
echo           the recommended method for initiating execution of this
echo           program is with the JAR execution mechanism. But if
echo           the class files were built on a unix system and will
echo           be executed on a windows system, then the manifest of
echo           the JAR file that was generated at build time will
echo           reference download extension JAR files through a
echo           unix-style file URL (no drive letter). Because of the
echo           mismatch in file system notations, executing the
echo           program using JAR execution will result in a
echo           NoClassDefFoundError. In this case, initiating
echo           execution through the program package and class name,
echo           with the -classpath property set, is advisable.
echo           (Default = JAR execution mechanism enabled).
echo  -groups  [set of lookup groups to join]
echo           (Default = %GROUPS%).
echo.
goto exitScript

:endScript
set CLASSPATH=%OLD_CLASSPATH%
set Path=%OLD_Path%
goto exitScript

:exitScript

